<template>
	<div class="d-inline-flex">
		<v-btn class="px-4" @click="showConfirmationDialog = true" v-bind="$attrs">Delete</v-btn>

		<confirm-dialog
			v-model="showConfirmationDialog"
			:title="`Delete stratification - ${stratification.id}`"
			:message="[
				'You will no longer be able to recover this stratification once you delete.',
				'If this is a demo stratification, and it has related sampling collections, they will be deleted also. You will not be warned if there are related sampling collections.',
				'Are you sure you want to delete?',
			]"
			:error="hasError ? error : null"
			:loading="isLoading"
			button="Delete"
			button-color="error"
			persistent
			@cleanup="clearError"
			@confirm="handleConfirmDelete"
		/>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { useStratifications } from '@/store/modules/stratifications';
import { Stratification } from '@/store/types';

export default defineComponent({
	components: { ConfirmDialog },
	inheritAttrs: false,
	props: {
		stratification: {
			type: Object as () => Stratification,
			required: true,
		},
	},
	setup(props, { root }) {
		const showConfirmationDialog = ref<boolean>(false);
		const { deleteStratification, clearError, isLoading, hasError, error: deleteError } = useStratifications(
			root.$store
		);
		const error = computed<string>(
			() =>
				deleteError.value?.response?.data?.message ||
				'An error occurred while attempting to delete a stratification. Please try again.'
		);

		const handleConfirmDelete = async () => {
			clearError();

			const success = await deleteStratification(props.stratification.id, true);

			if (success) {
				root.$store.dispatch('resources/getAllResources');
				showConfirmationDialog.value = false;
			}
		};

		return {
			showConfirmationDialog,
			handleConfirmDelete,
			clearError,
			isLoading,
			hasError,
			error,
		};
	},
});
</script>

<style></style>
